/* Sistemas Integrados TEKNISA

Nome: 8690_SUPTRGS.sql

Descrio:
Trigger para incluso de todas as regies na 
tabela REFOREG para o fornecedor que estiver sendo inserido.

Com essa trigger, ao incluir um fornecedor, automaticamente o sistema ir 
considerar que o mesmo no atende a nenhuma regio.

Criao:
04/03/2004 Ederson Melquades da Cunha
*/

IF EXISTS (SELECT
              NAME
           FROM
              SYSOBJECTS
           WHERE
              NAME = 'GRAVA_REFOREG_FORNECEDOR' AND
              TYPE = 'TR')
   DROP TRIGGER GRAVA_REFOREG_FORNECEDOR
GO

CREATE TRIGGER GRAVA_REFOREG_FORNECEDOR
ON FORNECEDOR
FOR INSERT

AS

DECLARE @V_NEW_CDFORNECED VARCHAR(21);

BEGIN
   DECLARE C_INSERTED CURSOR FOR
      SELECT 
         CDFORNECED
      FROM 
         INSERTED;

   OPEN C_INSERTED;

   FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFORNECED;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO REFOREG
         (CDREGIAO, 
          CDFORNECED)
      (SELECT 
          CDREGIAO, 
          @V_NEW_CDFORNECED
       FROM 
          REGIAO);
      FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFORNECED;
   END;

   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;
END;
GO
